freeslot(
"S_SERATRANSFORM",
"SPR_SESL"
)

states[S_SERATRANSFORM] = {
	sprite = SPR_SESL,
	frame = A|FF_ANIMATE|FF_FULLBRIGHT,
	tics = 8,
	var1 = 4, //frames
	var2 = 2, //animation speed
	nextstate = S_NULL,
}



local function seraTransFrame(seraSkin) //function that handles the custom animation
	
	local glow = P_SpawnMobjFromMobj(seraSkin.mo, 0,0,0, MT_THOK) //spawn object
	glow.state = S_SERATRANSFORM
	glow.target = seraSkin.mo
	glow.scale = seraSkin.mo.scale*3
	glow.color = seraSkin.skincolor
end



//thank you FrivolousAqua and SilicDev for letting me use this script!! i really appreciate it!!
// --
// Mimic Transformation Script
// Written by SilicDev
// Version 1.1
// --

local seraMaxTime = 35;

addHook("MobjThinker", function(m) 
    if not m.valid then
        return true
    end
    -- Note, internally these states are named S_MAGICIANBOX_TOP and S_MAGICIANBOX_BOTTOM
    if m.state == S_MAGICIANBOX or m.state == S_MAGICIANBOXTOP or m.state == S_MAGICIANBOXBOTTOM then 
        if m.target != nil and m.target.player != nil then
            -- Use the name of your own skin here
            if skins[m.target.player.skin].name == "starserathielr" then -- alternatively to apply to all ironman chars: skins[m.target.player.skin].flags & SF_IRONMAN != 0
                
				//trigger transformation effects
				m.target.player.seraTransforming = true
				m.target.player.seraTransformTime = seraMaxTime;
				
				m.state = S_NULL -- removes the object, to change the textures or behaviour change it to your own State here
            end
        end
    end
end, MT_MAGICIANBOX)



//script framework written by FrivolousAqua with additional help from FAVman33 (thanks guys) :]
//transformation effect

addHook("PlayerThink", function(p) //p is player
	if not p.seraTransforming then return end -- Don't run this if we aren't transforming (Sera)

	if p.seraTransformTime > 0 then -- Only run this while the timer's bigger than 0
    -- Do magic here
	
		if (p.seraTransformTime == seraMaxTime) or (p.seraTransformTime == (seraMaxTime - (seraMaxTime / 4))) then //triggers twice cause i think it's cool
			seraTransFrame(p) //trigger function seraTransFrame
		end
		
		K_SpawnSparkleTrail(p.mo)
		
		//these don't seem to work with ironman fakeskin, a shame
		//p.mo.color = SKINCOLOR_SUPERGOLD5
		//p.mo.colorized = true
		
		//debug message for testing
		//print(p, "\134Time remaining: " + p.seraTransformTime + " tic")
	
		p.seraTransformTime = p.seraTransformTime - 1 -- be sure to decrement this!
	else
		p.seraTransforming = false -- Set this to false, the timer's 0
	end
end)